
uint current_season = 7; // 3 - winter, 7 - spring, 11 - summer, 15 - fall. Up in 4 so training/tmgl will be placed between last season
uint current_year = 0;

const string NUMBER = "0123456789%-";
const string MAP_UPLOADS = 'xx but...';

// add activity, return is if finished current season and can stop
bool addActivity(Json::Value@ activity) {
    if (activity['activityType'] != 'campaign' && activity['activityType'] != 'map-upload') {
        return false;
    }
    Activity@ a = Activity(activity);
    if (onlyCurrentSeason && (a.year != current_year || a.season != current_season)) {
        // if in place this could be a reason to stop
        if (!a.unplaced) {
            if (a.season == 3 || a.season == 7 || a.season == 11 || a.season == 15) {
                return true;
            }
        }
        return false;
    }
    // xx but isn't a usable alteration
    // and if campaign id is 0 its also not a campaign
    if (a.alteration == MAP_UPLOADS || a.campaign == 0) {return false;}
    // for now tmgl alterations aren't included
    if (a.isTMGL) {return false;}
    // exclude royal (until I find a way to get finish time)
    if ((a.season == 8 && a.year == 2021)) {return false;}
    // exclude official campaign
    if (a.alteration == '') {return false;}
    // exclude prepatch stunt discovery
    if (a.alteration == '(old)') {return false;}
    // exclude campaigns with combined maps
    if (a.alteration == 'boss' || a.alteration == 'overlayed' || a.alteration == 'combined' || a.alteration == 'sections joined') {return false;}

    activities.InsertLast(a);
    return false;
}

class Activity {
    uint year = uint(-1); // latest year
    uint season = 4; // starts from 3, is winter. Goes up in 4 so I can fit training between
    string specialAlteration; // alteration part like cars and type
    string alteration; // just name of alteration
    uint id;
    uint campaign;
    uint position;
    string originalname;
    bool unplaced = false;
    bool istraining = false;
    bool isTMGL = false;
    string _string;

    Activity(Json::Value@ activity) {
        if (activity['mediaUrl'] == '' || bool(activity['featured']) == true) {
            unplaced = true;
        }
        this.id = uint(activity['id']);
        this.campaign = uint(activity['campaignId']);
        this.position = uint(activity['position']);
        this.originalname = Text::StripFormatCodes(string(activity['name']).Trim());
        string name = originalname.ToLower();
        bool hasyear = false;
        if (name.StartsWith('tmgl') || name.StartsWith('tmwt')) {
            this.isTMGL = true;
            name = name.SubStr(4).Trim();
            // name in club like 'TMGL Wi23 Podium'
        }
        if (name.StartsWith('kirbys')) { // a few altered kirby campaigns in AR's club
            this.isTMGL = true; // sorted out of normal campaign (I cba to add its own sorting category)
            name = name.SubStr(6).Trim();
        }
        if (name.StartsWith('training') || name.StartsWith('trng') || name.StartsWith('训练')) {
            if (name.StartsWith('training')) {
                name = name.SubStr(8).Trim();
            } else if (name.StartsWith('trng')) {
                name = name.SubStr(4).Trim();
            } else if (name.StartsWith('训练')) {
                name = name.SubStr(6) + name.SubStr(0, 6);;
            } else {
                name = name.SubStr(2).Trim();
            }
            this.season = current_season - 2;
            this.year = current_year;
            hasyear = true;
            this.istraining = true;
        // } else if (name.StartsWith('snow discovery') || name.StartsWith('snowdiscovery') || name.StartsWith('snwdiscovery') || name.StartsWith('snwdscvry') || name.StartsWith('sndsry') || name.StartsWith('sdsy')) {
        } else if (name.StartsWith('snow discovery') || name.StartsWith('snowdiscovery') || name.StartsWith('snowdscvry') || name.StartsWith('snowdsry') || name.StartsWith('snwd')) {
            if (name.StartsWith('snow discovery')) {
                name = name.SubStr(14).Trim();
            } else if (name.StartsWith('snowdiscovery')) {
                name = name.SubStr(13).Trim();
            } else if (name.StartsWith('snowdscvry')) {
                name = name.SubStr(10).Trim();
            } else if (name.StartsWith('snowdsry')) {
                name = name.SubStr(8).Trim();
            } else if (name.StartsWith('snwd')) {
                name = name.SubStr(4).Trim();
            }
            this.season = 0; // before winter 2024 (same as after fall 2023)
            this.year = 2024;
            hasyear = true;
        // } else if (name.StartsWith('rally discovery') || name.StartsWith('rallydiscovery') || name.StartsWith('rlydiscovery') || name.StartsWith('rlydscvry') || name.StartsWith('rldsry') || name.StartsWith('rdsy')) {
        } else if (name.StartsWith('rally discovery') || name.StartsWith('rallydiscovery') || name.StartsWith('rallydscvry') || name.StartsWith('rallydsry') || name.StartsWith('rallyd') || name.StartsWith('rlyd')) {
            if (name.StartsWith('rally discovery')) {
                name = name.SubStr(15).Trim();
            } else if (name.StartsWith('rallydiscovery')) {
                name = name.SubStr(14).Trim();
            } else if (name.StartsWith('rallydscvry')) {
                name = name.SubStr(11).Trim();
            } else if (name.StartsWith('rallydsry')) {
                name = name.SubStr(9).Trim();
            } else if (name.StartsWith('rallyd')) {
                name = name.SubStr(6).Trim();
            } else if (name.StartsWith('rlyd')) {
                name = name.SubStr(4).Trim();
            }
            this.season = 4; // before spring 2024 (same as after winter 2024)
            this.year = 2024;
            hasyear = true;
        // } else if (name.StartsWith('desert discovery') || name.StartsWith('desertdiscovery') || name.StartsWith('dstdiscovery') || name.StartsWith('dstdscvry') || name.StartsWith('dsdsry') || name.StartsWith('ddsy')) {
        } else if (name.StartsWith('desert discovery') || name.StartsWith('desertdiscovery') || name.StartsWith('desertdscvry') || name.StartsWith('desertdsry') || name.StartsWith('desertd') || name.StartsWith('dstd')) {
            if (name.StartsWith('desert discovery')) {
                name = name.SubStr(16).Trim();
            } else if (name.StartsWith('desertdiscovery')) {
                name = name.SubStr(15).Trim();
            } else if (name.StartsWith('desertdscvry')) {
                name = name.SubStr(12).Trim();
            } else if (name.StartsWith('desertdsry')) {
                name = name.SubStr(10).Trim();
            } else if (name.StartsWith('desertd')) {
                name = name.SubStr(7).Trim();
            } else if (name.StartsWith('dstd')) {
                name = name.SubStr(4).Trim();
            }
            this.season = 8; // before summer 2024 (same as after spring 2024)
            this.year = 2024;
            hasyear = true;
        } else if (name.StartsWith('stunt discovery') || name.StartsWith('stuntdiscovery') || name.StartsWith('stuntdscvry') || name.StartsWith('stuntdsry') || name.StartsWith('stuntd') || name.StartsWith('stnd')) {
            if (name.StartsWith('stunt discovery')) {
                name = name.SubStr(15).Trim();
            } else if (name.StartsWith('stuntdiscovery')) {
                name = name.SubStr(14).Trim();
            } else if (name.StartsWith('stuntdscvry')) {
                name = name.SubStr(11).Trim();
            } else if (name.StartsWith('stuntdsry')) {
                name = name.SubStr(9).Trim();
            } else if (name.StartsWith('stuntd')) {
                name = name.SubStr(6).Trim();
            } else if (name.StartsWith('stnd')) {
                name = name.SubStr(4).Trim();
            }
            this.season = 12; // after summer 2024
            this.year = 2024;
            hasyear = true;

       } else if (name.StartsWith('platform discovery') || name.StartsWith('platformdiscovery') || name.StartsWith('platformdscvry') || name.StartsWith('pltfmdscvry') || name.StartsWith('plfmdscvry') || name.StartsWith('plfmdsry') || name.StartsWith('plfmd') || name.StartsWith('plfd') || name.StartsWith('platformdsry')) {
            if (name.StartsWith('platform discovery')) {
                name = name.SubStr(18).Trim();
            } else if (name.StartsWith('platformdiscovery')) {
                name = name.SubStr(17).Trim();
            } else if (name.StartsWith('platformdscvry')) {
                name = name.SubStr(14).Trim();
            } else if (name.StartsWith('pltfmdscvry')) {
                name = name.SubStr(11).Trim();
            } else if (name.StartsWith('plfmdscvry')) {
                name = name.SubStr(10).Trim();
            } else if (name.StartsWith('plfmdsry')) {
                name = name.SubStr(8).Trim();
            } else if (name.StartsWith('plfmd')) {
                name = name.SubStr(5).Trim();
            } else if (name.StartsWith('plfd')) {
                name = name.SubStr(4).Trim();
            } else if (name.StartsWith('platformdsry')) {
                name = name.SubStr(12).Trim();
            }
            this.season = 0; // after fall 2024
            this.year = 2025;
            hasyear = true;
        } else if (name.StartsWith('weekly shorts') || name.StartsWith('weeklyshorts') || name.StartsWith('weekly s') || name.StartsWith('weekly') || name.StartsWith('week')) {
            if (name.StartsWith('weekly shorts')) {
                name = name.SubStr(13).Trim();
            } else if (name.StartsWith('weeklyshorts')) {
                name = name.SubStr(12).Trim();
            } else if (name.StartsWith('weekly s')) {
                name = name.SubStr(8).Trim();
            } else if (name.StartsWith('weekly')) {
                name = name.SubStr(6).Trim();
            } else if (name.StartsWith('week')) {
                name = name.SubStr(4).Trim();
            }
            this.season = 2; // before winter 2025
            this.year = 2025;
            hasyear = true;
        } else if (name.StartsWith('royal')) {
            this.season = 8;
            this.year = 2021;
            name = name.SubStr(5).Trim();
            hasyear = true;
        } else if (name.StartsWith('winter')) {
            this.season = 3;
            name = name.SubStr(6).Trim();
        } else if (name.StartsWith('spring')) {
            this.season = 7;
            name = name.SubStr(6).Trim();
        } else if (name.StartsWith('summer')) {
            this.season = 11;
            name = name.SubStr(6).Trim();
        } else if (name.StartsWith('fall')) {
            this.season = 15;
            name = name.SubStr(4).Trim();
        } else if (name.StartsWith('sprng')) {
            this.season = 7;
            name = name.SubStr(5).Trim();
        } else if (name.StartsWith('wntr')) {
            this.season = 3;
            name = name.SubStr(4).Trim();
        } else if (name.StartsWith('sprn')) {
            this.season = 7;
            name = name.SubStr(4).Trim();
        } else if (name.StartsWith('smmr')) {
            this.season = 11;
            name = name.SubStr(4).Trim();
        } else if (name.StartsWith('sumr')) {
            this.season = 11;
            name = name.SubStr(4).Trim();
        } else if (name.StartsWith('wi')) {
            this.season = 3;
            name = name.SubStr(2).Trim();
        } else if (name.StartsWith('sp')) {
            this.season = 7;
            name = name.SubStr(2).Trim();
        } else if (name.StartsWith('su')) {
            this.season = 11;
            name = name.SubStr(2).Trim();
        } else if (name.StartsWith('fa')) {
            this.season = 15;
            name = name.SubStr(2).Trim();
        } else if (name.StartsWith('夏季赛')) {
            this.season = 11;
            name = (name.SubStr(9) + name.SubStr(0, 9)).Trim();
        } else if (name.StartsWith('秋季')) {
            this.season = 15;
            name = (name.SubStr(6) + name.SubStr(0, 6)).Trim();
        } else {
            return;
        }
        if (this.isTMGL) {this.season--;}

        // get year
        if (!hasyear) {
            int i = 0;
            while (!NUMBER.Contains(name.SubStr(i, 1)) && i < name.Length) {
                i++;
                if (debugPrint) {
                    print('not year after season ' + name + ' from ' + this.originalname);
                }
            }
            if (i == name.Length) {
                this.year = uint(-1);
                this.alteration = name;
                return;
            }
            if (i > 0) {
                name = name.SubStr(i).Trim();
            }
            i = 0;
            while (NUMBER.Contains(name.SubStr(i, 1)) && i < name.Length) {
                i++;
            }
            string year = name.SubStr(0, i);
            name = name.SubStr(i).Trim();
            if (year.Length == 2) {
                year = "20" + year;
            }
            this.year = Text::ParseUInt(year);
        }
        if (name == '(alpha)') {name = '';} // spring 2020 has extra word after its name
        if (name == '(old') {name = '(old)';} // stunt discovery prepatch doesn't fit properly
        this.specialAlteration = '';
        if (name.StartsWith('[st]') || name.StartsWith('[stdm]') || name.StartsWith('[stadium]')) {
            if (name.StartsWith('[st]')) {
                this.specialAlteration += '[Stadium]';
                name = name.SubStr(4).Trim();
            } else if (name.StartsWith('[stdm]')) {
                this.specialAlteration += '[Stadium]';
                name = name.SubStr(6).Trim();
            } else {
                this.specialAlteration += '[Stadium]';
                name = name.SubStr(9).Trim();
            }
        }
        if (name.StartsWith('[sn]') || name.StartsWith('[snow]')) {
            if (name.StartsWith('[sn]')) {
                this.specialAlteration += '[Snow]';
                name = name.SubStr(4).Trim();
            } else {
                this.specialAlteration += '[Snow]';
                name = name.SubStr(6).Trim();
            }
        }
        if (name.StartsWith('[rl]') || name.StartsWith('[rally]')) {
            if (name.StartsWith('[rl]')) {
                this.specialAlteration += '[Rally]';
                name = name.SubStr(4).Trim();
            } else {
                this.specialAlteration += '[Rally]';
                name = name.SubStr(7).Trim();
            }
        }
        if (name.StartsWith('[ds]') || name.StartsWith('[dsrt]') || name.StartsWith('[desert]')) {
            if (name.StartsWith('[ds]')) {
                this.specialAlteration += '[Desert]';
                name = name.SubStr(4).Trim();
            } else if (name.StartsWith('[dsrt]')) {
                this.specialAlteration += '[Desert]';
                name = name.SubStr(6).Trim();
            } else {
                this.specialAlteration += '[Desert]';
                name = name.SubStr(8).Trim();
            }
        }
        if (name.StartsWith('[rc]') || name.StartsWith('[race]')) {
            if (name.StartsWith('[rc]')) {
                this.specialAlteration += '[Race]';
                name = name.SubStr(4).Trim();
            } else {
                this.specialAlteration += '[Race]';
                name = name.SubStr(6).Trim();
            }
        }
        if (name.StartsWith('[ry]') || name.StartsWith('[royal]')) {
            if (name.StartsWith('[rl]')) {
                this.specialAlteration += '[Royal]';
                name = name.SubStr(4).Trim();
            } else {
                this.specialAlteration += '[Royal]';
                name = name.SubStr(7).Trim();
            }
        }
        if (name.StartsWith('[st]') || name.StartsWith('[stunt]')) {
            if (name.StartsWith('[st]')) {
                this.specialAlteration += '[Stunt]';
                name = name.SubStr(4).Trim();
            } else {
                this.specialAlteration += '[Stunt]';
                name = name.SubStr(7).Trim();
            }
        }
        if (name.StartsWith('[pl]') || name.StartsWith('[plfm]') || name.StartsWith('[platform]')) {
            if (name.StartsWith('[pl]')) {
                this.specialAlteration += '[Platform]';
                name = name.SubStr(4).Trim();
            } else if (name.StartsWith('[plfm]')) {
                this.specialAlteration += '[Platform]';
                name = name.SubStr(6).Trim();
            } else {
                this.specialAlteration += '[Platform]';
                name = name.SubStr(10).Trim();
            }
        }

        name = checkStartNumber(name);

        this.alteration = name;
        if (this.alteration == 'xx but..') {
            this.alteration = MAP_UPLOADS;
        }

        this._string = this._ToString();
    }

    int opCmp (Activity@ b) { // 1 is this lower, -1 is this higher
        if (this.year > b.year) {
            return -1;
        } if (this.year < b.year) {
            return 1;
        }
        if (this.season > b.season) {
            return -1;
        } if (this.season < b.season) {
            return 1;
        }
        if (this.alteration == MAP_UPLOADS) {
            return -1;
        } if (b.alteration == MAP_UPLOADS) {
            return 1;
        }
        if (b.specialAlteration == '' && b.alteration == '') {
            return -1;
        } if (this.specialAlteration == '' && this.alteration == '') {
            return 1;
        }
        if (this.specialAlteration + this.alteration < b.specialAlteration + b.alteration) {
            return -1;
        } if (this.specialAlteration + this.alteration > b.specialAlteration + b.alteration) {
            return 1;
        }
        return this.originalname.opCmp(b.originalname);
    }
    bool opEquals (Activity@ b) {
        return this.id == b.id;
    }

    string getSeason() {
        if (this.year == uint(-1) || this.year == uint(-2) || this.year == 0 || this.year == 1) {
            return 'Unknown';
        }
        if (this.season == 0 && this.year == 2024) {
            return '\\$fffSnow Discovery\\$z';
        } else if (this.season == 4 && this.year == 2024) {
            return '\\$fffRally Discovery\\$z';
        } else if (this.season == 8 && this.year == 2024) {
            return '\\$fffDesert Discovery\\$z';
        } else if (this.season == 12 && this.year == 2024) {
            return '\\$fffStunt Discovery\\$z';
        } else if (this.season == 0 && this.year == 2025) {
            return '\\$fffPlatform Discovery\\$z';
        } else if (this.season == 8 && this.year == 2021) {
            return '\\$7dfRoyal\\$z';
        } else if (this.season == 2 && this.year == 2025) {
            return '\\$fffWeekly Shorts\\$z';
        } else {
            switch (this.season) {
                case 3: return '\\$9feWinter\\$z ' + this.year;
                case 7: return '\\$df7Spring\\$z ' + this.year;
                case 11: return '\\$fd6Summer\\$z ' + this.year;
                case 15: return '\\$e91Fall\\$z ' + this.year;
                case 2: return '\\$a22TMGL \\$9feWinter\\$z ' + this.year;
                case 6: return '\\$a22TMGL \\$df7Spring\\$z ' + this.year;
                case 10: return '\\$a22TMGL \\$fd6Summer\\$z ' + this.year;
                case 14: return '\\$a22TMGL \\$e91Fall\\$z ' + this.year;
                case 1: return '\\$a22Training\\$z';
                case 5: return '\\$a22Training\\$z';
                case 9: return '\\$a22Training\\$z';
                case 13: return '\\$a22Training\\$z';
                // case ?: return Text::OpenplanetFormatCodes(this.originalname); // 0 is needed for snowdiscovery so default is now ?
                default: 
                    if (debugPrint) {print('unknown season: ' + this.season + ' on ' + this.originalname);}
                    return 'Unknown';
            }
        }
    }
    string ToString() {
        return this._string;
    }
    string _ToString() {
        if (this.year == uint(-1) || this.year == uint(-2) || this.year == 0 || this.year == 1) {
            return this.originalname;
        }
        string s = getSeason();
        if (s == 'Unknown') {
            Text::OpenplanetFormatCodes(this.originalname);
        }
        return "" + s + " " + this.specialAlteration + (this.specialAlteration == '' ? '' : ' ') + getAlterationName(this.alteration, this.originalname);
    }
    
    void getMaps() {
        if(activityMaps.Exists(tostring(this.campaign))) {return;}
        string campaignurl = NadeoServices::BaseURLLive() + "/api/token/club/" + tostring(selected_club) + "/campaign/" + this.campaign;
        // request all the maps in the campaign
        while (!NadeoServices::IsAuthenticated("NadeoLiveServices")) {yield();}
        Net::HttpRequest@ req = NadeoServices::Get("NadeoLiveServices", campaignurl);
        req.Start();
        while(!req.Finished()) {yield();}
        if (req.ResponseCode() != 200) {
            print('invalid http response when getting campaign maps' + req.ResponseCode() + ', ' + req.String());
        }
        Json::Value@ response = Json::Parse(req.String());
        if (!response.HasKey('campaign') || !response['campaign'].HasKey('playlist')) {
            print('invalid response when getting campaign maps ' + req.String());
            return;
        }
        if (response['campaign']['playlist'].Length == 0) {
            print('campaign with no maps: ' + campaignurl);
            return;
        }
        // parse the map uids out of the response into a normal array
        array<string>@ responsemaps = {};
        for (uint i = 0; i < response['campaign']['playlist'].Length; i++) {
            responsemaps.InsertLast(response['campaign']['playlist'][i]['mapUid']);
        }
        // activityMaps[tostring(this.campaign)] = responsemaps;
        SetMapsFromUidList(this, responsemaps);

    }
}

// Alterations such as 1up are sorted as up1 instead of all being first
string checkStartNumber(string &in name) {
    while (name.Length > 0 && NUMBER.Contains(name.SubStr(0, 1))) {
        string num = name.SubStr(0, 1);
        name = name.SubStr(1) + num;
    }
    return name.Trim();
}