/*
 * by ArEyeses
 * 
 */


enum Process {
    Working,
    UnknownClub,
    BadClubId,
    NoActivities,
    GetActivities,
    HasActivities
}

Process process = Process::UnknownClub;

Activity@[] activities = {};
dictionary activityMaps = {};
// time activities were loaded
uint64 activitiesTime = 0;
// time duration to reuse loaded activities on a new run
const uint64 reuseActivitiesTime = 60 * 60 * 1000;

void Main() {
    NadeoServices::AddAudience("NadeoLiveServices");
    // @digitalFont = UI::LoadFont("digital-7.mono.ttf", 20);
    // set skip medal on UI after settings have loaded
    while (!NadeoServices::IsAuthenticated("NadeoLiveServices")) {
        yield();
    }
    GetCurrentSeason();

    while (true) {
        if (process == Process::UnknownClub) {
            CheckClubId();
        } else if (process == Process::GetActivities) {
            GetClubActivities();
            Run::updateMaps();
        }
        if (Run::status == Run::Status::ToRollMap && process == Process::HasActivities) {
            Run::rollNewMap();
        }
        yield();
    }
}

void Update(float dt) {
    Run::update();
    Wheel::update();
}
